import { ValueObject } from '@mobicoop/ddd-library';

/** Note:
 * Value Objects with multiple properties can contain
 * other Value Objects inside if needed.
 * */

export interface MarginDurationsProps {
  mon?: number;
  tue?: number;
  wed?: number;
  thu?: number;
  fri?: number;
  sat?: number;
  sun?: number;
}

export class MarginDurations extends ValueObject<MarginDurationsProps> {
  get mon(): number {
    return this.props.mon;
  }

  set mon(margin: number) {
    this.props.mon = margin;
  }

  get tue(): number {
    return this.props.tue;
  }

  set tue(margin: number) {
    this.props.tue = margin;
  }

  get wed(): number {
    return this.props.wed;
  }

  set wed(margin: number) {
    this.props.wed = margin;
  }

  get thu(): number {
    return this.props.thu;
  }

  set thu(margin: number) {
    this.props.thu = margin;
  }

  get fri(): number {
    return this.props.fri;
  }

  set fri(margin: number) {
    this.props.fri = margin;
  }

  get sat(): number {
    return this.props.sat;
  }

  set sat(margin: number) {
    this.props.sat = margin;
  }

  get sun(): number {
    return this.props.sun;
  }

  set sun(margin: number) {
    this.props.sun = margin;
  }

  // eslint-disable-next-line @typescript-eslint/no-unused-vars
  protected validate(props: MarginDurationsProps): void {
    return;
  }
}
